#include "mex.h"
#include <math.h>
#include <stdio.h>
#include <omp.h>
#include "param.h"

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[]) {
    /* Some initialization */
    int i, j, k;
    double *x= mxGetPr(prhs[0]);
    int nx = mxGetN(prhs[0]);
    int d = mxGetM(prhs[0]);
    double *z= mxGetPr(prhs[1]);
    int nz = mxGetN(prhs[1]);
    double *sig = mxGetPr(prhs[2]);
    double *EXPSIG = (double*)calloc(d,sizeof(double));
    double *K;
    plhs[0]=mxCreateDoubleMatrix(nx, nz, mxREAL);
    K =  mxGetPr(plhs[0]);

    for(k=0;k<d;k++)/* Pre compute exp(sig) for speed up*/
        EXPSIG[k]=exp(sig[k]);
    
    double Ktp;
    #pragma omp parallel for private(i, j, k, Ktp) shared(x, z, K, nx, nz) num_threads(MAX_THREADS) schedule(static)
    for(j=0;j<nz;j++){
        for(i=0;i<nx;i++){            
            Ktp=0;
            for(k=0;k<d;k++)
                Ktp += (x[i*d+k]-z[j*d+k])*(x[i*d+k]-z[j*d+k])*EXPSIG[k];
            K[i+j*nx]= exp(-0.5*Ktp);
        }
    }
    free(EXPSIG);
}