function [sig cv_m cv]=cross_validation_knn(x,y,r_sigma,v)
% Compute the cross validation to select otptimal parameter
% x: the sample
% y: the variable
% r_theta: the range of selected theta
% r_sig: the range of selected sig
% v: Number of splits in the CV

% Initialization
n_sigma = length(r_sigma);
cv= zeros(n_sigma,1);

% Split the data
n=size(y,1);
t=floor(n/v);
if(t==0)
    t=1;
end
perm = randperm(n);
c=zeros(v,t);

for i=1:v
    c(i,:) = perm(1+(i-1)*t:i*t);
end

for i =1:n_sigma
    oa_t=0;
    for l=1:v
        xt=x(c(setdiff([1:v],l),:),:); % for the training
        yt=y(c(setdiff([1:v],l),:),:); % remove set i from the training set
        xT=x(c(l,:),:); %for testing
        yT=y(c(l,:),:);
        
        
        yp = knn(xt,yt,xT,r_sigma(i),'sphere');
        oa_t = oa_t+confusion(yT,yp);        
    end
    cv(i)=oa_t/v;    
end
[cv_m,i]=max(cv(:));
sig=r_sigma(i);