function yp = knn(x,y,xt,sig,kernel,k)
% Compute the knn classifier 
% x = training samples, n x d matrix
% y = training labels, d x 1 vector
% xt = testing samples, nt x d matrix
% sig = kernel parameters
% kernel = 'sphere', 'ellipse', 'chol'

% Some preprocessing
[n d]=size(x);
nt = size(xt,1);

% Compute the kernel matrix
switch kernel
    case 'sphere'
        K = compute_kernel_sphere(xt',x',sig);
    case 'ellipse'
        K = compute_kernel_ellipse(xt',x',sig);
    case 'chol'
        K = compute_kernel_chol(xt',x',sig);
end
K = bsxfun(@minus,K,1);
K = bsxfun(@times,K,-2);

if nargin == 5
    [~,idx]=min(K,[],2);
    yp = y(idx);
    clear K idx;
else
    [~,idx] = sort(K, 2, 'ascend');
    idx = idx(:,1:k);
    yp = mode(y(idx),2);
    clear K idx;
end
        