 function [data M m] =scale(data,M,m)
%
% function data =rescale(data)
%
% This function rescale the input data between -1 and 1
%
% INPUT
%
% data: the data to rescale
% max: the maximum value of the ouput data
% min: the minimum value of the output data
% 
% OUTPUT
%
% data: the rescaled data
[Nb_s Nb_b]=size(data);
if nargin==1
    M=max(data,[],1);
    m=min(data,[],1);
end

data = bsxfun(@minus,data,m);
data = 2*bsxfun(@times,data,1./(M-m))-1;